<?php
/**
 * Invision Power Services
 * IP.Board v3.0.1
 * 123flashchat Management
 *
 * @author 		$Author: TopCMM $
 * @copyright	(c) 2001 - 2010 TopCMM, Inc.
 * @license		http://www.invisionpower.com/community/board/license.html
 * @package		Invision Power Board
 * @subpackage	123flashchat
 * @link		http://www.123flashchat.com
 */

if ( ! defined( 'IN_ACP' ) )
{
	print "<h1>Incorrect access</h1>You cannot access this file directly. If you have recently upgraded, make sure you upgraded 'admin.php'.";
	exit();
}
require_once(dirname(dirname(dirname(__FILE__))).'/extensions/functions.php');
class admin_123flashchat_123flashchat_settings extends ipsCommand 
{
	/**
	 * Skin file
	 *
	 * @access	public
	 * @var		object
	 */
	public $html;	
	public $fcsetting;
	
	/**
	 * Main execution method
	 *
	 * @access	public
	 * @param	object		ipsRegistry reference
	 * @return	void
	 */
	public function doExecute( ipsRegistry $registry ){
        ini_set("default_socket_timeout",5);
		/* Load Skin and Lang */
		$this->html               = $this->registry->output->loadTemplate( 'cp_skin_123flashchat' );
		$this->html->form_code    = 'module=123flashchat&amp;section=settings';
		$this->html->form_code_js = 'module=123flashchat&section=settings';		
		$this->lang->loadLanguageFile( array( 'admin_123flashchat' ) );
		switch( $this->request['do'] ){
			case 'save':
				$this->flashchatSave();
			break;			
			case 'list':				
			default:
				$this->flashchatForm(array());
			break;
		}
		
		/* Output */
		$this->registry->output->html_main .= $this->registry->output->global_template->global_frame_wrapper();
		$this->registry->output->sendOutput();			
	}
	
	/**
	 * Handles the 123flashchat settings form
	 *
	 * @access	public
	 * @return	void
	 */
	public function flashchatSave(){
		/* INIT */
		$fcsetting = array();
		
		$fcsetting['fc_extendserver'] = intval( $this->request['extendserver'] );
		//$fcsetting['fc_camshow'] = $this->request['camshow'];
		switch ($fcsetting['fc_extendserver']){
	        case 0:
	            $error = $this->saveFcOwnConfig($fcsetting);
	            break;
	        case 1:
	            $error = $this->saveFcHostConfig($fcsetting);
	            break;
	        case 2:
	            $error = $this->saveFcFreeConfig($fcsetting);
	            break;
		}
		
		if(is_array($error)){
			$this->flashchatForm($error);
		}else{
		    $this->flashchatForm('success');
		}
	}
	
	private function saveFcOwnConfig($fcsetting){
		$client_location = $this->request['client_loc'];
		if($client_location){
			$fcsetting['fc_client_loc'] = $client_location . (substr($client_location,-1,1) != '/' ? '/' : '');
			
			$serverinfo = $this->getServerHostPortLocal($fcsetting['fc_client_loc']);
            $fcsetting['fc_server_host'] = !empty($this->request['server_host']) ? $this->request['server_host'] : (empty($serverinfo['fc_server_host']) ? $_SERVER['HTTP_HOST'] : $serverinfo['fc_server_host']) ;
            $fcsetting['fc_server_host_s'] = empty($serverinfo['fc_server_host_s']) ? $_SERVER['HTTP_HOST'] : $serverinfo['fc_server_host_s'];
            $fcsetting['fc_server_host_h'] = empty($serverinfo['fc_server_host_h']) ? $_SERVER['HTTP_HOST'] : $serverinfo['fc_server_host_h'];
            if(!is_numeric($this->request['server_port']) || strpos($this->request['server_port'] ,".")!==false){
            	$fcsetting['fc_server_port'] = empty($serverinfo['fc_server_port']) ? '51127' : $serverinfo['fc_server_port'] ;
            }else{
            	$fcsetting['fc_server_port'] = $this->request['server_port'];
            }
            if(!is_numeric($this->request['server_port_h']) || strpos($this->request['server_port_h'] ,".")!==false){
            	$fcsetting['fc_server_port_h'] = empty($serverinfo['fc_server_port_h']) ? '35555' : $serverinfo['fc_server_port_h'] ;
            }else{
            	$fcsetting['fc_server_port_h'] = $this->request['server_port_h'];
            }
            $fcsetting['fc_server_port_s'] = empty($serverinfo['fc_server_port_s']) ? '51128' : $serverinfo['fc_server_port_s'] ;
            $fcsetting['fc_api_url'] = 'http://' . $fcsetting['fc_server_host'] . ':' . $fcsetting['fc_server_port_h'] . '/';
		}else{
			$fcsetting['fc_server_host'] = $_SERVER['HTTP_HOST'];
            $fcsetting['fc_server_host_h'] = $fcsetting['fc_server_host_s'] = $fcsetting['fc_server_host'];            
            $fcsetting['fc_server_port_h'] = '35555';
            $fcsetting['fc_server_port_s'] = '51128';
            $fcsetting['fc_server_port'] = '51127';
            $fcsetting['fc_api_url'] = 'http://' . $fcsetting['fc_server_host'] . ':' . $fcsetting['fc_server_port_h'] . '/';
            $fcsetting['fc_client_loc'] = $fcsetting['fc_api_url'];            
		}       	
		$s_own_loc = 1;
		$c_own_loc = 1;
		$da = 1;
		if($this->request['server_loc']){
			$c_own_loc = validate_client($fcsetting['fc_client_loc']);
			$da = validate_data_api($fcsetting['fc_api_url'] . 'online.js');
			if($c_own_loc || $da){
				$error[] = 'Chat Server host or port is configured incorrectly';
			}
		}else{
			$c_own_loc = validate_client($fcsetting['fc_client_loc']);
			if($c_own_loc){
				$error[] = 'Chat Server http_port or Client location is configured incorrectly';
			}
		}
		$check = validate_client('http://'.parse_url($fcsetting['fc_client_loc'], PHP_URL_HOST).':'.$fcsetting['fc_server_port_h'].'/');
		if($check){
			$error[] = 'Client Location is configured incorrectly';
		}
		if($error){
			return $error;
		}else{
			$fcsetting = $this->saveFcPublicConfig($fcsetting);
			$this->doSaveFcConfig($fcsetting);
			return true;
		}
	}
	
	private function saveFcHostConfig($fcsetting){
		$fcsetting['fc_client_loc'] = $this->request['client_loc'] ? ($this->request['client_loc'] . (substr($this->request['client_loc'],-1,1) != '/' ? '/' : '')) : '';
		if(empty($fcsetting['fc_client_loc'])){
			$error[] = 'Client Location is Empty!';
		}
		$serverinfo = $this->getServerHostPortHost($fcsetting['fc_client_loc']);
		if($serverinfo){					
			$fcsetting['fc_server_host'] = empty($serverinfo['fc_server_host']) ? parse_url($fcsetting['fc_client_loc'], PHP_URL_HOST) : $serverinfo['fc_server_host'];
			$fcsetting['fc_server_host_s'] = empty($serverinfo['fc_server_host_s']) ? '' : $serverinfo['fc_server_host_s'];
			$fcsetting['fc_server_host_h'] = empty($serverinfo['fc_server_host_h']) ? '' : $serverinfo['fc_server_host_h'];
			$fcsetting['fc_server_port'] = empty($serverinfo['fc_server_port']) ? '' : $serverinfo['fc_server_port'];
			$fcsetting['fc_server_port_h'] = empty($serverinfo['fc_server_port_h']) ? '' : $serverinfo['fc_server_port_h'];
            $fcsetting['fc_server_port_s'] = empty($serverinfo['fc_server_port_s']) ? '' : $serverinfo['fc_server_port_s'];
            $fcsetting['fc_api_url'] = 'http://' . $fcsetting['fc_server_host'] . '/';
            $fcsetting['fc_group'] = substr(parse_url($fcsetting['fc_client_loc'], PHP_URL_PATH),1,-1);
			$c_own_loc = validate_client($fcsetting['fc_client_loc']);
			$da = validate_data_api($fcsetting['fc_api_url'] . 'online.js?group=' . $fcsetting['fc_group']);
	        if($c_own_loc || $da){
	        	$error[] = 'Client Location is configured incorrectly';
	        }
		}else{
			$error[] = 'Client Location is configured incorrectly';
		}
				
		if($error){
			return $error;
		}else{
			$fcsetting = $this->saveFcPublicConfig($fcsetting);
			$this->doSaveFcConfig($fcsetting);
			return true;
		}
	}
	
	private function saveFcFreeConfig($fcsetting){
		$fcsetting['fc_room'] = $this->request['room'] ? $this->request['room'] : 'Lobby';
		$fcsetting = $this->saveFcPublicConfig($fcsetting);
		$this->doSaveFcConfig($fcsetting);
		return true;
	}
	
	private function saveFcPublicConfig($fcsetting){
		$fcsetting['fc_room_list'] = $this->request['room_list'];
		$fcsetting['fc_user_list'] = $this->request['user_list'];
		$fcsetting['fc_fullscreen'] = $this->request['fullscreen'];
		$fcsetting['fc_client_mode'] = $this->request['client_mode'];
		//if($fcsetting['fc_camshow'] == 1){
		//	$fcsetting['fc_client_width'] = ($this->request['client_width'] && is_numeric($this->request['client_width']) && $this->request['client_width'] >=860) ? $this->request['client_width'] : 860;
		//	$fcsetting['fc_client_height'] = ($this->request['client_height'] && is_numeric($this->request['client_height']) && $this->request['client_height'] >=642) ? $this->request['client_height'] : 642;
		//}else{
			$fcsetting['fc_client_width'] = ($this->request['client_width'] && is_numeric($this->request['client_width']) && $this->request['client_width'] >=468) ? $this->request['client_width'] : 758;
			$fcsetting['fc_client_height'] = ($this->request['client_height'] && is_numeric($this->request['client_height']) && $this->request['client_height'] >=360) ? $this->request['client_height'] : 560;
		//}		
	    $fcsetting['fc_client_lang'] = $this->request['client_lang'];
		$fcsetting['fc_client_skin'] = $this->request['client_skin'];
		return $fcsetting;
	}
	
	private function doSaveFcConfig($fcsetting){
		 $this->DB->update( '123flashchat', $fcsetting, "id = 1");
		 //$this->DB->update( '123flashchat', array('fc_server_host'=>'test','fc_extendserver' => 3), "id = 1");
	}
	
	/**
	 * Add/Edit 123flashchat Form
	 *
	 * @access	public
	 * @param	string	$type	Either new or edit
	 * @return	void
	 */
	public function flashchatForm($error = array()){
		//-----------------------------------------
		// Init Vars
		//-----------------------------------------
	    $fcsetting = $this->get_fc_config();
	    $fcsetting['fc_error'] = '';
		if(is_array($error)){
			$error_info = '';
			foreach($error as $value){
				$error_info .= '<p>'.$value.'</p>';
			}
			//$fcsetting['fc_error'] .= '<div class="warning"><h4>Save Error</h4>'.$error_info.'</div>'; 
			$this->registry->output->global_error = $error_info;
		}elseif($error == 'success'){
			$this->registry->output->global_message = "Save Success!";
		}
		$valid = getValid($fcsetting);		
		/* Output */
		$this->registry->output->html .= $this->html->flashchatForm( $fcsetting, $valid );	
	}	

	private function get_fc_config(){
		$this->DB->build( array( 'select' => '*',
			'from'   => '123flashchat',
			'where'  => "id=1")
		);
		$this->DB->execute();
		$result = $this->DB->fetch();
		return $result;
	}
    
	private function getServerHostPortLocal($client_location){
		$content = topcmmRequestRemote::requestRemote($client_location.'htmlchat/config/config.js',1);
		if ($content){
			//server host
		 	preg_match('/init_host = "([a-zA-Z0-9.]*)";/', $content, $matches);
	        if(isset($matches[1])){
	        	$data['fc_server_host'] = $matches[1];			        	
	        }else{
		        preg_match('/init_host="([a-zA-Z0-9.]*)";/', $content, $matches);
		        if(isset($matches[1])){
		        	$data['fc_server_host'] = $matches[1];			        	
		        }else{
		        	$data['fc_server_host'] = '';
		        }
	        }
	        //server port
	        preg_match('/init_port = ([0-9]*);/', $content, $matches);
	        if(isset($matches[1])){
	        	$data['fc_server_port'] = $matches[1];			        	
	        }else{
	        	$data['fc_server_port'] = '';
	        }
	        //server host s
			preg_match('/init_host_s = "([a-zA-Z0-9.]*)";/', $content, $matches);
	        if(isset($matches[1])){
	        	$data['fc_server_host_s'] = $matches[1];			        	
	        }else{
		        preg_match('/init_host_s="([a-zA-Z0-9.]*)";/', $content, $matches);
		        if(isset($matches[1])){
		        	$data['fc_server_host_s'] = $matches[1];			        	
		        }else{
		        	$data['fc_server_host_s'] = '';
		        }
	        }
	        //server port s
	        preg_match('/init_port_s = ([0-9]*);/', $content, $matches);
	        if(isset($matches[1])){
	        	$data['fc_server_port_s'] = $matches[1];			        	
	        }else{
	        	$data['fc_server_port_s'] = '';
	        }
	        //server host h
			preg_match('/init_host_h = "([a-zA-Z0-9.]*)";/', $content, $matches);
	        if(isset($matches[1])){
	        	$data['fc_server_host_h'] = $matches[1];			        	
	        }else{
		        preg_match('/init_host_h="([a-zA-Z0-9.]*)";/', $content, $matches);
		        if(isset($matches[1])){
		        	$data['fc_server_host_h'] = $matches[1];			        	
		        }else{
		        	$data['fc_server_host_h'] = '';
		        }
	        }
	        //server port h
	        preg_match('/init_port_h = ([0-9]*);/', $content, $matches);
	        if(isset($matches[1])){
	        	$data['fc_server_port_h'] = $matches[1];			        	
	        }else{
	        	$data['fc_server_port_h'] = '';
	        }
	        return $data;
	    }else{
	    	return false;
	    }
	}

	private function getServerHostPortHost($client_location){
		$content = topcmmRequestRemote::requestRemote($client_location,1);
		if ($content){
			//server port
			preg_match('/init_port=([0-9]*)/', $content, $matches);
	        if(isset($matches[1])){
	        	$data['fc_server_port'] = $matches[1];			        	
	        }
	        //server port s
			preg_match('/init_port_s=([0-9]*)/', $content, $matches);
	        if(isset($matches[1])){
	        	$data['fc_server_port_s'] = $matches[1];			        	
	        }
	        //server port h
			preg_match('/init_port_h=([0-9]*)/', $content, $matches);
	        if(isset($matches[1])){
	        	$data['fc_server_port_h'] = $matches[1];			        	
	        }
	        //server host
			preg_match('/init_host=([a-zA-Z0-9.]*)/', $content, $matches);
	        if(isset($matches[1])){
	        	$data['fc_server_host'] = $matches[1];			        	
	        }
	        //server host s
			preg_match('/init_host_s=([a-zA-Z0-9.]*)&/', $content, $matches);
	        if(isset($matches[1])){
	        	$data['fc_server_host_s'] = $matches[1];			        	
	        }
	        //server host h
			preg_match('/init_host_h=([a-zA-Z0-9.]*)&/', $content, $matches);
	        if(isset($matches[1])){
	        	$data['fc_server_host_h'] = $matches[1];			        	
	        }
	        return $data;
	    }else{
            return false;
	    }
	}
}
